from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Float, Int

Idmassaccuracy_V0_1_0 = CommandToolBuilder(tool="IDMassAccuracy", base_command=["IDMassAccuracy"], inputs=[ToolInput(tag="in_in", input_type=File(optional=True), prefix="-in", doc=InputDocumentation(doc="*                      Input mzML file list, containing the spectra. (valid formats: 'mzML')")), ToolInput(tag="in_id_in", input_type=File(optional=True), prefix="-id_in", doc=InputDocumentation(doc="*                   Input idXML file list, containing the identifications. (valid formats: 'idXML')")), ToolInput(tag="in_out_precursor", input_type=File(optional=True), prefix="-out_precursor", doc=InputDocumentation(doc="Output file which contains the deviations from the precursors (valid formats: 'tsv')")), ToolInput(tag="in_precursor_error_ppm", input_type=Boolean(optional=True), prefix="-precursor_error_ppm", doc=InputDocumentation(doc="If this flag is used, the precursor mass tolerances are estimated in ppm instead of Da.")), ToolInput(tag="in_out_fragment", input_type=File(optional=True), prefix="-out_fragment", doc=InputDocumentation(doc="Output file which contains the fragment ion m/z deviations (valid formats: 'tsv')")), ToolInput(tag="in_fragment_error_ppm", input_type=Boolean(optional=True), prefix="-fragment_error_ppm", doc=InputDocumentation(doc="If this flag is used, the fragment mass tolerances are estimated in ppm instead of Da.")), ToolInput(tag="in_fragment_mass_tolerance", input_type=Float(optional=True), prefix="-fragment_mass_tolerance", doc=InputDocumentation(doc="Maximal fragment mass tolerance which is allowed for MS/MS spectra, used for the calculation of matching ions. (default: '0.5')")), ToolInput(tag="in_ini", input_type=File(optional=True), prefix="-ini", doc=InputDocumentation(doc="Use the given TOPP INI file")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="-threads", doc=InputDocumentation(doc="Sets the number of threads allowed to be used by the TOPP tool (default: '1')")), ToolInput(tag="in_write_ini", input_type=File(optional=True), prefix="-write_ini", doc=InputDocumentation(doc="Writes the default configuration file")), ToolInput(tag="in_helphelp", input_type=Boolean(optional=True), prefix="--helphelp", doc=InputDocumentation(doc="Shows all options (including advanced)"))], outputs=[ToolOutput(tag="out_out_precursor", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_precursor", type_hint=File()), doc=OutputDocumentation(doc="Output file which contains the deviations from the precursors (valid formats: 'tsv')")), ToolOutput(tag="out_out_fragment", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_fragment", type_hint=File()), doc=OutputDocumentation(doc="Output file which contains the fragment ion m/z deviations (valid formats: 'tsv')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Idmassaccuracy_V0_1_0().translate("wdl", allow_empty_container=True)

